#include <stdio.h>
#include <stdlib.h>
#include "rigidbody.h"

void read_rigid_body_parameters(FILE *fp, RigidBody *rb)
{
   fscanf(fp, "%f %f %f", rb->x, rb->x+1, rb->x+2);
   fscanf(fp, "%f %f %f %f", rb->q, rb->q+1, rb->q+2, rb->q+3);
   fscanf(fp, "%f %f %f", rb->v, rb->v+1, rb->v+2);
   fscanf(fp, "%f %f %f", rb->L, rb->L+1, rb->L+2);
   fscanf(fp, "%f", &rb->M);
   fscanf(fp, "%f %f %f", rb->inertiaTinv, rb->inertiaTinv+1, rb->inertiaTinv+2);
   rb->inertiaT[0]=1.0/(rb->inertiaTinv[0]+1e-20); // could be zero if this is immovable
   rb->inertiaT[1]=1.0/(rb->inertiaTinv[1]+1e-20);
   rb->inertiaT[2]=1.0/(rb->inertiaTinv[2]+1e-20);
}

void write_rigid_body_parameters(FILE *fp, const RigidBody *rb)
{
   fprintf(fp, "%.7g %.7g %.7g\n", rb->x[0], rb->x[1], rb->x[2]);
   fprintf(fp, "%.7g %.7g %.7g %.7g\n", rb->q[0], rb->q[1], rb->q[2], rb->q[3]);
   fprintf(fp, "%.7g %.7g %.7g\n", rb->v[0], rb->v[1], rb->v[2]);
   fprintf(fp, "%.7g %.7g %.7g\n", rb->L[0], rb->L[1], rb->L[2]);
   fprintf(fp, "%.7g\n", rb->M);
   fprintf(fp, "%.7g %.7g %.7g\n", rb->inertiaTinv[0], rb->inertiaTinv[1], rb->inertiaTinv[2]);
}

void make_rigid_body_parameters_of_block(RigidBody *rb, float xrange, float yrange, float zrange, float mass)
{
   // fill in all but phi and mesh for the (homogeneous) block from -xrange/2 to xrange/2, -yrange/2 to yrange/2, -zrange/2 to zrange/2,
   // with given mass
}

void make_rigid_body_parameters_of_sphere(RigidBody *rb, float radius, float mass)
{
   // fill in all but phi and mesh for the (solid, homogeneous) sphere of given radius and mass
}

