// vector and quaternion utilities
// you may want to add your own shortcuts in this file

#ifndef VECTORS_H
#define VECTORS_H

#include <math.h>

static inline void add_v(float x[3], const float y[3])
{
   x[0]+=y[0];
   x[1]+=y[1];
   x[2]+=y[2];
}

// make norm of x equal to 1
static inline void normalize_v(float x[3])
{
   float overmag=1./(sqrt(x[0]*x[0]+x[1]*x[1]+x[2]*x[2]));
   x[0]*=overmag;
   x[1]*=overmag;
   x[2]*=overmag;
}

// make norm of q equal to 1
static inline void normalize_q(float q[4])
{
   float overmag=1./(sqrt(q[0]*q[0]+q[1]*q[1]+q[2]*q[2]+q[3]*q[3]));
   q[0]*=overmag;
   q[1]*=overmag;
   q[2]*=overmag;
   q[3]*=overmag;
}

// rotate vector p by unit-norm quaternion q (on both sides) and put result in x
static inline void rotate_qv(const float q[4], const float p[3], float x[3])
{
}

// form the product q1*q2 and store it in q2
static inline void compose_q(const float q1[4], float q2[4])
{
}

// from a unit norm quaternion q form the equivalent rotation matrix R
static inline void q_to_R(const float q[4], float R[3][3])
{
}

// compute x=R*p
static inline void multiply_Rv(const float R[3][3], const float p[3], float x[3])
{
}

#endif
